<?xml version="1.0"?>
<launch>
    <!-- MAVROS posix SITL environment launch script -->
    <!-- launches MAVROS, PX4 SITL, Gazebo environment, and spawns vehicle -->
    <!-- vehicle pose -->
    <arg name="x" default="0"/>
    <arg name="y" default="0"/>
    <arg name="z" default="0"/>
    <arg name="R" default="0"/>
    <arg name="P" default="0"/>
    <arg name="Y" default="0"/>
    <!-- vehicle model and world -->
    <arg name="est" default="ekf2"/>
	<!-- model name -->
    <arg name="vehicle" default="iris"/>
    <!-- <arg name="my_vehicle" default="iris_opt_flow"/> -->
    <!-- <arg name="my_vehicle" default="iris_fpv_cam"/> -->
    <arg name="world" default="$(find mavlink_sitl_gazebo)/worlds/empty.world"/>
    <arg name="sdf" default="$(find mavlink_sitl_gazebo)/models/$(arg vehicle)/$(arg vehicle).sdf"/>
    <arg name="script_directory" default="" />
    <arg name="rviz_enable" default="true" />

    <!-- gazebo configs -->
    <arg name="gui" default="true"/>
    <arg name="debug" default="false"/>
    <arg name="verbose" default="true"/>
    <arg name="paused" default="false"/>
    <arg name="respawn_gazebo" default="false"/>

    <!-- MAVROS configs -->
    <arg name="fcu_url" default="udp://:14540@localhost:14557"/>
	<arg name="gcs_url" default="" />
	<arg name="tgt_system" default="1" />
	<arg name="tgt_component" default="1" />
	<arg name="log_output" default="screen" />
	<arg name="fcu_protocol" default="v2.0" />
	<arg name="respawn_mavros" default="false" />
	<arg name="config_file" default="$(arg script_directory)/../config/mavros_config.yaml" />

    <!-- Static tranform depth camera to base_link -->
    <node pkg="tf" type="static_transform_publisher" name="depth_to_uav_link_tf"
	    args="0 0 0 0 0 0 base_link depth_sensor_link 10">
    </node>

    <group if="$(arg rviz_enable)">
        <node name="rviz" pkg="rviz" type="rviz" args="-d $(arg script_directory)/../config/config.rviz" />
    </group>
    
    <!-- PX4 configs -->
    <arg name="interactive" default="true"/>
    <env name="PX4_SIM_MODEL" value="$(arg vehicle)" />

    <!-- PX4 SITL -->
    <arg unless="$(arg interactive)" name="px4_command_arg1" value="-d"/>
    <arg     if="$(arg interactive)" name="px4_command_arg1" value=""/>
    <node name="sitl" pkg="px4" type="px4" output="screen"
        args="$(find px4)/build/px4_sitl_default/etc -s etc/init.d-posix/rcS $(arg px4_command_arg1)" required="true"/>

    <!-- Gazebo sim -->
    <include file="$(find gazebo_ros)/launch/empty_world.launch">
        <arg name="gui" value="$(arg gui)"/>
        <arg name="world_name" value="$(arg world)"/>
        <arg name="debug" value="$(arg debug)"/>
        <arg name="verbose" value="$(arg verbose)"/>
        <arg name="paused" value="$(arg paused)"/>
        <arg name="respawn_gazebo" value="$(arg respawn_gazebo)"/>
    </include>

    <!-- gazebo model -->
    <node name="$(anon vehicle_spawn)" pkg="gazebo_ros" type="spawn_model" output="screen" args="-sdf -file $(arg sdf) -model $(arg vehicle) -x $(arg x) -y $(arg y) -z $(arg z) -R $(arg R) -P $(arg P) -Y $(arg Y)"/>

    <!-- MAVROS -->
    <include file="$(find mavros)/launch/node.launch">
		<arg name="pluginlists_yaml" value="$(arg script_directory)/../config/mavros_pluginlists.yaml" />
		<arg name="config_yaml" value="$(arg script_directory)/../config/mavros_config.yaml" />
		<arg name="fcu_url" value="$(arg fcu_url)" />
		<arg name="gcs_url" value="$(arg gcs_url)" />
		<arg name="tgt_system" value="$(arg tgt_system)" />
		<arg name="tgt_component" value="$(arg tgt_component)" />
		<arg name="log_output" value="$(arg log_output)" />
		<arg name="fcu_protocol" value="$(arg fcu_protocol)" />
		<arg name="respawn_mavros" default="$(arg respawn_mavros)" />
	</include>

    <!-- Load params to px4 -->
    <node pkg="mavros" type="mavparam" name="param_loader"
        launch-prefix="bash -c 'sleep 5; $0 $@'"
	    args="load $(arg script_directory)/../config/px4.params">
    </node>

</launch>
